/*
								 ***********
								** Summary **
								 ***********

					  Copyright 2001, Nagual Enterprises
				Please see COPYING for the complete GNU license

	(1)	Title:
				TES:2 Daggerfall SaveTreeBrowser Classes

	(2)	Purpose:
			To supply the data structures needed to access the
			contents of a Daggerfall saved game.

	(3)	Change history:
			Please see the RCS logs.

	(4)	Definitions:

			Constants:
				browser_			--	Include already processed flag.

			Macros:

			Classes:
				SaveGameBrowser		--	Class to manage access to the data
									--	in a saved game.

			Assertions about definitions:
				Note that some implementations of C++ impose alignment
				restrictions on C++ classes and so we prefer to use
				structs in those cases where that imposed alignment may
				clash with the raw data streams being modelled.  That way,
				sizeof() and [] do the right thing without juggling the
				books.

	(5)	References:

			Include files:
				chunk.h				--	File stream for savetree.dat

			Methods:
				Please see the class scaffold for methods.

			Classes:
				***  None  ***

			Assertions about the references:
				chunk.h must be included prior to this header file.

								 ********
								** Text **
								 ********
*/

#ifndef browser_
#	define browser_

		/*	Prototype for operations to perform on the saved game data. */

	class SaveGameBrowser;

	class SaveGameBrowser
	{
/*
					 ********************
					** Instance methods **
					**  and  variables  **
					 ********************
*/

	protected:
		SaveTree* _game;				//	Saved game file stream.
		char** _cliIndex;				//	Additional command line
										//	arguments.

	public:
		SaveGameBrowser() :
			_game(NULL),
			_cliIndex(NULL) {};
		SaveGameBrowser(SaveTree* g, char** ci) :
			_game(g),
			_cliIndex(ci) {};
		~SaveGameBrowser() {};

		char** cliIndex()				//	Answer the pointer to a
			{return _cliIndex;}			//	command line token.
		void cliIndex(char** ci)		//	Assign the pointer to the
			{_cliIndex = ci;}			//	command line tokens.
		SaveTree* game()				//	Answer the saved game stream.
			{return _game;}
		void game(SaveTree* g)			//	Assign the pointer to the
			{_game = g;}				//	saved game stream.

/*
					 *****************
					** Class methods **
					** and variables **
					 *****************
*/

	};



#endif					/*	browser_ */
